{

fsc fido library
(c) 1999-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
unit rFidoMsg;
interface
uses Objects, rAbs, rObjects;
{}
const
{}
 MsgTrm   : array[1..3] of Char = #0#2#0;  { msg terminator }
 PktTrm   : array[1..3] of Char = #0#0#0;  { pkt terminator }
 qMsgTrm  : array[1..2] of Char = #2#0;    { short msg terminator }
 qPktTrm  : array[1..2] of Char = #0#0;    { short pkt terminator }
 msgLastRead: pChar = 'lastread.rvn';
{}
type
{( Header of Fido *.msg )}
 tMsgHdr = record
  OrigName   : array[1..36] of Char;{  p⥫ }
  DestName   : array[1..36] of Char;{  y⥫ }
  Subject    : array[1..72] of char;{  subject }
  Date       : array[1..20] of char;{ ᨬ쭠  ᮧ [dd mmm yy hh:mm:ss] }
  TimesRead  : System.Word;         { number of times message read }
  DestNode   : System.Word;         { hp  y⥫ }
  OrigNode   : System.Word;         { hp  p⥫ }
  Cost       : System.Word;         { ⮨ p뫪 쬠 }
  OrigNet    : System.Word;         { hp  p⥫ }
  DestNet    : System.Word;         { hp  y⥫ }
  DateWritten: System.longint;      {  ᮧ (dos p) }
  DateArrived: System.longint;      {  p/뫪 (dos p) }
  ReplyTo    : System.Word;         { 㪠⥫  py饥 쬮 }
  Attr       : System.Word;         { ᪠ py⮢ }
  ReplyNext  : System.Word;         { 㪠⥫  ᫥y饥 쬮 }
 end;
{( header of fsc-048 packet )}
 pPktHdr = ^tPktHdr;
 tPktHdr = record
  OrigNode   : System.Word;         {  ࠢ⥫ }
  DestNode   : System.Word;         {  ⥫ }
  Year       : System.Word;         {  }
  Month      : System.Word;         {  }
  Day        : System.Word;         {  }
  Hour       : System.Word;         {  }
  Minute     : System.Word;         {  }
  Second     : System.Word;         { ᥪ }
  Baud       : System.Word;         {  -   :-( }
  PacketType : System.Word;         { ᥣ 0002h !!! - ⨯  }
  OrigNet    : System.Word;         { ⪠ ࠢ⥫ }
  DestNet    : System.Word;         { ⪠ ⥫ }
  PrdCodL    : System.Byte;         { ftsc product code (low)  (0) }
  PVMajOr    : System.Byte;         { ftsc product rev (major) (0) }
  Password   : array[1..8] of Char; { ஫ }
  QOrgZone   : System.Word;         { = origzone (zmailq,qmail) (?) }
  QDstZone   : System.Word;         { = destzone (zmailq,qmail) (?) }
  Filler     : array[1..4] of char; { spare change }
  PrdCodH    : System.Byte;         { ftsc product code (high) (0) }
  PVMinor    : System.Byte;         { ftsc product rev (minor) (0) }
  CapWord    : System.Word;         { capability word }
  OrigZone   : System.Word;         {  ࠢ⥫ }
  DestZone   : System.Word;         {  ⥫ }
  OrigPoint  : System.Word;         {   ࠢ⥫ }
  DestPoint  : System.Word;         {   砥 }
  ProdData   : System.LongInt;      { product-specific data (?) }
  PktHdrEnd  : System.Word;         { ନ-2 }
 end;
{
ps (?) -    ⭮ ७  㦭. ᫨  ᭨ - 
         ⮫쪮 ࠤ :)
}
{( static header of fsc-048 packet message )}
 tPktMsgHdr = record
  OrigNode   : System.Word;         { p  p⥫ }
  DestNode   : System.Word;         { p  y⥫ }
  OrigNet    : System.Word;         { p  p⥫ }
  DestNet    : System.Word;         { p  y⥫ }
  Attr       : System.Word;         { ᪠ py⮢ }
  Cost       : System.Word;         { ⮨ p뫪 쬠 }
  Date       : array[1..20] of Char;{ ᨬ쭠  ᮧ [dd mmm yy hh:mm:ss] }
 end;
{( tFscBase )}
 pFscBase = ^tFscBase;
 tFscBase = object(tAbsBase)
  function    SaveMsgBody(var Msg: tAbsMsg; FromPos: Longint): Byte; virtual;
 end;
{( tMsgBase )}
 pMsgBase = ^tMsgBase;
 tMsgBase = object(tFscBase)
  MsgHdr    : TMsgHdr;
  constructor Init;
  destructor  Done; virtual;
  function    LoadBaseHdr(fn: String; aShareMode: Word): Byte; virtual;
  function    SaveBaseHdr(fn: String; aShareMode: Word): Byte; virtual;
  function    ExistMsg(Number: Longint): Boolean; virtual;
  function    LoadMsg(var Msg: tAbsMsg; Number: Longint): Byte; virtual;
  function    SaveMsg(var Msg: tAbsMsg; Number: Longint): Byte; virtual;
  function    DeleteMsg(Number: LongInt): Byte; virtual;
  function    LoadMsgReplies(var Msg: tAbsMsg; Number: Longint): Byte; virtual;
  procedure   AbsData2MsgHdr(var Msg: tAbsMsg; r: Boolean); virtual;
  function    CalcMsgName(Fill: Boolean): String;
 end;
{( TCoord )}
 PCoords = ^TCoords;
 TCoords = object(TObject)
  c: LongInt;
  constructor Init(p: LongInt);
 end;
{( tPktBase )}
 pPktBase = ^tPktBase;
 tPktBase = object(tFscBase)
  PktHdr    : tPktHdr;
  PktMsgHdr : tPktMsgHdr;
  Coords    : pCollection;
  Kills     : pPosCol;
  constructor Init;
  destructor  Done; virtual;
  destructor  dummy; virtual;

  function    GetSourceAddress: String; virtual;
  function    GetDestinationAddress: String; virtual;
  function    GetPassWord: String; virtual;

  procedure   SetSourceAddress(s: String); virtual;
  procedure   SetDestinationAddress(s: String); virtual;
  procedure   SetPassword(s: String); virtual;

  function    LoadBaseHdr(fn: String; aShareMode: Word): Byte; virtual;
  function    SaveBaseHdr(fn: String; aShareMode: Word): Byte; virtual;
  function    LoadMsg(var Msg: tAbsMsg; Number: Longint): Byte; virtual;
  function    SaveMsg(var Msg: tAbsMsg; Number: Longint): Byte; virtual;
  function    DeleteMsg(Number: LongInt): Byte; virtual;
  function    LoadMsgReplies(var Msg: tAbsMsg; Number: Longint): Byte; virtual;
  function    PackPkt: Byte;
  procedure   AbsData2MsgHdr(var Msg: tAbsMsg; r: Boolean); virtual;
 end;
{}
 function    FastPktSave(Name: String; var Msg: tAbsMsg): Byte;
{}
implementation
Uses Strings, rStrings, rTime, rCommon, Dos;
{( tFscBase )}
function    tFscBase.SaveMsgBody;
 var
  x: Longint;
 begin
  SaveMsgBody:=1;
  if @Msg=nil then exit;
  if MainLink=nil then exit;
  with Msg.AbsMsgData do
   begin
    if (GetPS(Area)='') then
     begin
      if (OrigPoint<>0) then StreamWriteLn(MainLink^,klFMPT+NToC(OrigPoint),cr);
      if (DestPoint<>0) then StreamWriteLn(MainLink^,klTOPT+NToC(DestPoint),cr);
      if (GetPS(INTL)<>'') then StreamWriteLn(MainLink^,klINTL+GetPS(INTL),cr);
     end;
    if (GetPS(MsgID)<>'') then StreamWriteLn(MainLink^,klMsgID+GetPS(MsgID),cr);
    if (GetPS(Reply)<>'') then StreamWriteLn(MainLink^,klReply+GetPS(Reply),cr);
    if (GetPS(Flags)<>'') then StreamWriteLn(MainLink^,klFlags+GetPS(Flags),cr);
    if (GetPS(PID)<>'') then StreamWriteLn(MainLink^,klPID+GetPS(PID),cr);
    if (GetPS(TID)<>'') then StreamWriteLn(MainLink^,klTID+GetPS(TID),cr);
    if (Msg.OtherCol^.Count>0) then for x:=0 to Msg.OtherCol^.Count-1 do
    StreamWriteLn(MainLink^,GetPS(Msg.OtherCol^.At(x)),cr);
   end;
  with Msg do
   begin
    MsgBody^.Reset;
    MsgBody^.Seek(0);
    MainLink^.CopyFrom(MsgBody^,MsgBody^.GetSize);
    with AbsMsgData do
     begin
      if ((GetPS(TearLine)<>'') and (TearLined)) then StreamWriteLn(MainLink^,bTearLine+GetPS(TearLine),cr);
      if ((GetPS(Origin)<>'') or (GetPS(Area)<>'')) and (Origined) then
      StreamWriteLn(MainLink^,bOrigin+GetPS(Origin)+Bracket1+GetSourceAddress+Bracket2,cr);
     end;

    with Msg.SeenBy^ do if Count>0 then for x:=0 to Count-1 do StreamWriteLn(MainLink^,klSeenBy+GetPS(At(x)),cr);
    with Msg.Path^ do if Count>0 then for x:=0 to Count-1 do StreamWriteLn(MainLink^,klPath+GetPS(At(x)),cr);

    if ViaCol^.Count>0 then for x:=0 to ViaCol^.Count-1 do StreamWriteLn(MainLink^,GetPS(ViaCol^.At(x)),cr);
   end;
 end;
{( tMsgBase )}
constructor tMsgBase.Init;
 begin
  inherited init;
  FillChar(MsgHdr,SizeOf(tPkthdr),0);
 end;
{}
destructor  tMsgBase.Done;
 begin
  inherited done;
  FillChar(MsgHdr,SizeOf(tPkthdr),0);
 end;
{}
function    tMsgBase.LoadBaseHdr;
 begin
  LoadBaseHdr:=inherited LoadBaseHdr(fn,aShareMode);
  DisposeObj(LastLink);
  if (Exist(AddBackSlash(JustPathName(GetPS(BaseFileName)))+StrPas(msgLastRead))) then
  LastLink:=
  New(pBufStream,Init(AddBackSlash(JustPathName(GetPS(BaseFileName)))+StrPas(msgLastRead),stOpen or ShareMode,BlockSize))
  else
  LastLink:=
  New(pBufStream,Init(AddBackSlash(JustPathName(GetPS(BaseFileName)))+StrPas(msgLastRead),stCreate or ShareMode,BlockSize));
  Count:=CToN(ExtractWord(1,JustFileName(CalcMsgName(true)),[Point]))-1;
  BaseStatus:=bsOpened;
  if Count<0 then Count:=0;
  LoadBaseHdr:=0;
 end;
{}
function    tMsgBase.SaveBaseHdr;
 begin
  SaveBaseHdr:=inherited SaveBaseHdr(fn,aShareMode);
  DisposeObj(LastLink);
  if Exist(AddBackSlash(GetPS(BaseFileName))+StrPas(msgLastRead)) then
  LastLink:=New(pBufStream,Init(AddBackSlash(GetPS(BaseFileName))+StrPas(msgLastRead),stOpen or ShareMode,BlockSize))
  else LastLink:=New(pBufStream,Init(AddBackSlash(GetPS(BaseFileName))+StrPas(msgLastRead),stCreate or ShareMode,BlockSize));
  Count:=CToN(ExtractWord(1,JustFileName(CalcMsgName(true)),[Point]))-1;
  BaseStatus:=bsOpened;
  if Count<0 then Count:=0;
  SaveBaseHdr:=0;
 end;
{}
function    tMsgBase.ExistMsg;
 begin
  ExistMsg:=Exist(AddBackSlash(JustPathName(GetPS(BaseFileName)))+NToC(Number)+Point+JustExtension(GetPS(BaseFileName)));
 end;
{}
function    tMsgBase.LoadMsg;
 begin
  LoadMsg:=inherited LoadMsg(Msg,Number);
  if (BaseStatus<>bsOpened) then exit;
  if @Msg=nil then exit;
  if not ExistMsg(Number) then exit;
  MainLink:=
  New(pBufStream,Init(AddBackSlash(JustPathName(GetPS(BaseFileName)))+NToC(Number)+Point+JustExtension(GetPS(BaseFileName)),
                      stOpenRead or ShareMode,BlockSize));
  Msg.FreeMessage;
  if MainLink^.Status<>0 then
   begin
    DisposeObj(MainLink);
    exit;
   end;
  MainLink^.Read(MsgHdr,SizeOf(tMsgHdr));
  AbsData2MsgHdr(Msg,True);
  LoadMsgBody(Msg,MainLink^.GetPos,MainLink^.GetSize);
  Msg.ProcessFlags(true);
  Msg.ParseKludges;
  DisposeObj(MainLink);
  Msg.MsgStatus:=msLoaded;
  LoadMsg:=0;
 end;
{}
function    tMsgBase.SaveMsg;
 begin
  SaveMsg:=inherited SaveMsg(Msg,Number);
  if (BaseStatus<>bsOpened) then exit;
  if @msg=nil then exit;
  Msg.ProcessFlags(false);
  AbsData2MsgHdr(Msg,false);
  MainLink:=
  New(pBufStream,Init(AddBackSlash(JustPathName(GetPS(BaseFileName)))+NToC(Number)+Point+JustExtension(GetPS(BaseFileName)),
                      stCreate or ShareMode,BlockSize));
  if MainLink^.Status<>0 then
   begin
    DisposeObj(MainLink);
    exit;
   end;
  MainLink^.Write(MsgHdr,SizeOf(tMsgHdr));
  SaveMsgBody(Msg,MainLink^.GetPos);
  Msg.MsgStatus:=msSaved;
  Inc(Count);
  DisposeObj(MainLink);
  SaveMsg:=0;
 end;
{}
function    tMsgBase.DeleteMsg;
 begin
  DeleteMsg:=inherited DeleteMsg(Number);
  if (BaseStatus<>bsOpened) then exit;
  if not ExistMsg(Number) then exit;
  KillFile(AddBackSlash(JustPathName(GetPS(BaseFileName)))+NToC(Number)+Point+JustExtension(GetPS(BaseFileName)));
  DeleteMsg:=0;
 end;
{}
function    tMsgBase.LoadMsgReplies;
 begin
  LoadMsgReplies:=inherited LoadMsgReplies(Msg,Number);
  if (BaseStatus<>bsOpened) then exit;
  if @Msg=nil then exit;
  if not ExistMsg(Number) then exit;
  LoadMsgReplies:=LoadMsg(msg,Number);
 end;
{}
procedure   tMsgBase.AbsData2MsgHdr;
 begin
  inherited AbsData2MsgHdr(Msg,r);
  if R then with Msg.AbsMsgData do
   begin
    ReallocStr(OrigName,StrPas(@MsgHdr.OrigName));
    ReallocStr(DestName,StrPas(@MsgHdr.DestName));
    ReallocStr(Subject,StrPas(@MsgHdr.Subject));
    Date:=StrPas(@MsgHdr.Date);
    TimesRead:=MsgHdr.TimesRead;
    UnPackTime(MsgHdr.DateWritten,DateWritten);
    UnPackTime(MsgHdr.DateArrived,DateArrived);
    if (not ValidTime(Msg.AbsMsgData.DateWritten)) then GetCurrentTime(Msg.AbsMsgData.DateWritten);
    if (not ValidTime(Msg.AbsMsgData.DateArrived)) then GetCurrentTime(Msg.AbsMsgData.DateArrived);
    OrigNode:=MsgHdr.OrigNode;
    DestNode:=MsgHdr.DestNode;
    OrigNet:=MsgHdr.OrigNet;
    DestNet:=MsgHdr.DestNet;
    Attr:=MsgHdr.Attr;
    FillChar(Replies,SizeOf(Msg.AbsMsgData.Replies),#0);
    Replies[1]:=MsgHdr.ReplyNext;
{  ᮢ⨬ opus/fido }
    FillChar(Msg.AbsMsgData.DateWritten,SizeOf(Msg.AbsMsgData.DateWritten),#0);
    FillChar(Msg.AbsMsgData.DateArrived,SizeOf(Msg.AbsMsgData.DateArrived),#0);
   end
  else with MsgHdr do
   begin
    FillChar(MsgHdr,SizeOf(MsgHdr),#0);
    StrPCopy(@OrigName,GetPS(Msg.AbsMsgData.OrigName));
    StrPCopy(@DestName,GetPS(Msg.AbsMsgData.DestName));
    StrPCopy(@Subject,GetPS(Msg.AbsMsgData.Subject));
    Msg.AbsMsgData.Date:=GetFscTime(Msg.AbsMsgData.DateWritten);
    StrPCopy(@Date,Msg.AbsMsgData.Date);
    TimesRead:=Msg.AbsMsgData.TimesRead;
    if (not ValidTime(Msg.AbsMsgData.DateWritten)) then GetCurrentTime(Msg.AbsMsgData.DateWritten);
    if (not ValidTime(Msg.AbsMsgData.DateArrived)) then GetCurrentTime(Msg.AbsMsgData.DateArrived);
    PackTime(Msg.AbsMsgData.DateWritten,DateWritten);
    PackTime(Msg.AbsMsgData.DateArrived,DateArrived);
    Msg.AbsMsgData.Date:=GetFscTime(Msg.AbsMsgData.DateWritten);
    StrPCopy(@Date,Msg.AbsMsgData.Date);
    DestNode:=Msg.AbsMsgData.DestNode;
    OrigNode:=Msg.AbsMsgData.OrigNode;
    DestNet:=Msg.AbsMsgData.DestNet;
    OrigNet:=Msg.AbsMsgData.OrigNet;
    Attr:=Msg.AbsMsgData.Attr;
    ReplyNext:=Msg.AbsMsgData.Replies[1];
{  ᮢ⨬ opus/fido }
    MsgHdr.DateWritten:=0;
    MsgHdr.DateArrived:=0;
   end;
 end;
{}
function    tMsgBase.CalcMsgName;
 const
  Limit: LongInt = 99999999;
 var
  MsgMask: String;
  MsgDir: String;
 procedure CalcMsgFill;
  var
   d: SearchRec;
   z,MaxMin: LongInt;
  begin
   MaxMin:=0; z:=0; FillChar(d,SizeOf(d),#0);
   FindFirst(MsgDir+MsgMask,AnyFile,d);
   while DosError=0 do
    begin
     z:=CToN(ExtractWord(1,d.name,['.']));
     if z>MaxMin then MaxMin:=z;
     FindNext(d);
    end;
   CalcMsgName:=MsgDir+NToC(MaxMin+1)+'.'+JustExtension(MsgMask);
{$IfDef VirtualPascal}
   FindClose(d);
{$EndIf}
  end;
 procedure CalcMsgWFill;
  var
   x: LongInt;
   MsgExt: String;
  begin
   MsgExt:='.'+ExtractWord(2,MsgMask,['.']);
   for x:=1 to Limit do if Not Exist(MsgDir+NToC(x)+MsgExt) then
    begin
     CalcMsgName:=MsgDir+NToC(x)+MsgExt;
     break;
    end;
  end;
 begin
  CalcMsgName:='';
  MsgDir:=AddBackSlash(JustPathName(GetPS(BaseFileName)));
  MsgMask:=JustFileName(GetPS(BaseFileName));
  if Not DExist(MsgDir) then exit;
  if fill then CalcMsgFill else CalcMsgWFill;
 end;
{( TCoord )}
constructor TCoords.Init;
 begin
  c:=p;
 end;
{( tPktBase )}
constructor tPktBase.Init;
 begin
  inherited init;
  FillChar(PktHdr,SizeOf(tPkthdr),0);
  FillChar(PktMsgHdr,SizeOf(tPktMsghdr),0);
  New(Coords,Init(16,16));
  New(Kills,Init(16,16));
 end;
{}
destructor  tPktBase.Done;
 begin
  PackPkt;
  inherited done;
  DisposeObj(Kills);
  DisposeObj(Coords);
  FillChar(PktHdr,SizeOf(tPkthdr),0);
  FillChar(PktMsgHdr,SizeOf(tPktMsghdr),0);
  DisposeObj(MainLink);
 end;
{}
destructor  tPktBase.Dummy;
 begin
 end;
{}
function    tPktBase.GetSourceAddress;
 var
  s: String;
 begin
  s:=NToC(PktHdr.OrigZone)+DualPoint
   + NToC(PktHdr.OrigNet) +Slash
   + NToC(PktHdr.OrigNode);
  if PktHdr.OrigPoint>0 then s:=s+'.'+ NToC(PktHdr.OrigPoint);
  GetSourceAddress:=s;
 end;
{}
function    tPktBase.GetDestinationAddress;
 var
  s: String;
 begin
  s:=NToC(PktHdr.DestZone)+DualPoint
   + NToC(PktHdr.DestNet) +Slash
   + NToC(PktHdr.DestNode);
  if PktHdr.DestPoint<>0 then s:=s+'.'+ NToC(PktHdr.DestPoint);
  GetDestinationAddress:=s;
 end;
{}
function    tPktBase.GetPassWord;
 begin
  GetPassWord:=StrPas(PChar(@PktHdr.PassWord));
 end;
{}
procedure   tPktBase.SetSourceAddress;
 begin
  PktHdr.QOrgZone :=CToN(ExtractWord(1,S,FidoChars));
  PktHdr.OrigZone :=CToN(ExtractWord(1,S,FidoChars));
  PktHdr.OrigNet  :=CToN(ExtractWord(2,S,FidoChars));
  PktHdr.OrigNode :=CToN(ExtractWord(3,S,FidoChars));
  PktHdr.OrigPoint:=CToN(ExtractWord(4,S,FidoChars));
 end;
{}
procedure   tPktBase.SetDestinationAddress;
 begin
  PktHdr.QDstZone :=CToN(ExtractWord(1,S,FidoChars));
  PktHdr.DestZone :=CToN(ExtractWord(1,S,FidoChars));
  PktHdr.DestNet  :=CToN(ExtractWord(2,S,FidoChars));
  PktHdr.DestNode :=CToN(ExtractWord(3,S,FidoChars));
  PktHdr.DestPoint:=CToN(ExtractWord(4,S,FidoChars));
 end;
{}
procedure   tPktBase.SetPassword;
 begin
  if Byte(s[0])>8 then Byte(s[0]):=8;
  FillChar(PktHdr.PassWord,SizeOf(PktHdr.PassWord),#0);
  StrPCopy(pChar(@PktHdr.passWord),s);
 end;
{}
function    tPktBase.LoadBaseHdr;
 var
  p: Longint;
 begin
  LoadBaseHdr:=inherited LoadBaseHdr(fn,aShareMode);
  DisposeObj(MainLink);
  MainLink:=New(pBufStream,Init(GetPS(BaseFileName),stOpen or ShareMode,BlockSize));
  if MainLink^.Status<>0 then
   begin
    DisposeObj(MainLink);
    exit;
   end;
  MainLink^.Read(PktHdr,SizeOf(tPktHdr));
  if (MainLink^.Status<>0) or (MainLink^.GetSize=60) then
   begin
    BaseStatus:=bsOpened;
    LoadBaseHdr:=0;
    exit;
   end;
  if PktHdr.PacketType<>2 then
   begin
    BaseStatus:=bsOpenError;
    DisposeObj(MainLink);
    exit;
   end;
  Coords^.FreeAll;
  Kills^.FreeAll;
  Coords^.Insert(New(PCoords,Init(57)));
  MainLink^.Seek(60+SizeOf(TPktMsgHdr));
  repeat
   p:=StreamFindStr(MainLink^,@MsgTrm,SizeOf(MsgTrm),true);
   if (P<0) then
    begin
     MainLink^.Reset;
     if MainLink^.GetSize>60 then Coords^.Insert(New(PCoords,Init(MainLink^.GetSize-3)));
     break;
    end
   else
    begin
     Coords^.Insert(New(PCoords,Init(p)));
    end;
   MainLink^.Seek(p+3+SizeOf(TPktMsgHdr));
  until p=-1;
  BaseStatus:=bsOpened;
  Count:=Coords^.Count-1;
  LoadBaseHdr:=0;
 end;
{}
function    tPktBase.SaveBaseHdr;
 var
  x: word;
  p: Longint;
{$IfDef VirtualPascal}
  x1,x2,x3,xx: Longint;
{$EndIf}
 begin
  SaveBaseHdr:=inherited SaveBaseHdr(fn,aShareMode);
  DisposeObj(MainLink);
  if not Exist(GetPS(BaseFileName)) then MainLink:=New(pBufStream,Init(GetPS(BaseFileName),stCreate or ShareMode,BlockSize))
  else MainLink:=New(pBufStream,Init(GetPS(BaseFileName),stOpen or ShareMode,BlockSize));
  PktHdr.PacketType:=$0002;
  with PktHdr do
   begin
{$IfDef VirtualPascal}
    GetDate(x1,x2,x3,xx);
    Year:=x1; Month:=x2; Day:=x3;
{$EndIf}
{$IfDef Ver70}
    GetDate(Year,Month,Day,x);
{$EndIf}
    Dec(Month);
{$IfDef VirtualPascal}
    GetTime(x1,x2,x3,xx);
    Hour:=x1; Minute:=x2; Second:=x3;
{$EndIf}
{$IfDef Ver70}
    GetTime(Hour,Minute,Second,x);
{$EndIf}
   end;
  if MainLink^.GetSize<=SizeOf(PktHdr) then PktHdr.PktHdrEnd:=$0000 else PktHdr.PktHdrEnd:=$0002;
  MainLink^.Write(PktHdr,SizeOf(PktHdr));
  if (MainLink^.Status<>0) or (MainLink^.GetSize=60) then
   begin
    BaseStatus:=bsOpened;
    SaveBaseHdr:=0;
    exit;
   end;
  if PktHdr.PacketType<>2 then
   begin
    BaseStatus:=bsOpenError;
    DisposeObj(MainLink);
    exit;
   end;
  Coords^.FreeAll;
  Kills^.FreeAll;
  Coords^.Insert(New(PCoords,Init(57)));
  MainLink^.Seek(60+SizeOf(TPktMsgHdr));
  repeat
   p:=StreamFindStr(MainLink^,@MsgTrm,SizeOf(MsgTrm),true);
   if (P<0) then
    begin
     MainLink^.Reset;
     if MainLink^.GetSize>60 then Coords^.Insert(New(PCoords,Init(MainLink^.GetSize-3)));
     break;
    end
   else
    begin
     Coords^.Insert(New(PCoords,Init(p)));
    end;
   MainLink^.Seek(p+3+SizeOf(TPktMsgHdr));
  until p=-1;
  BaseStatus:=bsOpened;
  Count:=Coords^.Count-1;
  SaveBaseHdr:=0;
 end;
{}
function    tPktBase.LoadMsg;
 var
  CoordsObj: pCoords;
  p,p1,p2: Longint;
  s: String;
 begin
  LoadMsg:=inherited LoadMsg(Msg,Number);
  if (BaseStatus<>bsOpened) then exit;
  if @Msg=nil then Exit;
  if not ExistMsg(Number) then exit;
  if (Number>Coords^.Count-1) or (Number<1) then exit;
  Msg.FreeMessage;
  Msg.FillHeaders;
  CoordsObj:=Coords^.At(Number-1); p1:=CoordsObj^.c+3;
  CoordsObj:=Coords^.At(Number); p2:=CoordsObj^.c;
  MainLink^.Seek(p1);
  MainLink^.Read(PktMsgHdr,SizeOf(PktMsgHdr));
  with Msg.AbsMsgData do
   begin
    StreamReadLnAsAsciiZ(MainLink^,s);
    ReallocStr(DestName,s);
    StreamReadLnAsAsciiZ(MainLink^,s);
    ReallocStr(OrigName,s);
    StreamReadLnAsAsciiZ(MainLink^,s);
    ReallocStr(Subject,s);
    p:=MainLink^.GetPos;
    StreamReadLn(MainLink^,s);
    MainLink^.Reset;
    if (UpStr(Copy(s,1,Length(klArea)))=UpStr(klArea)) then ReallocStr(Msg.AbsMsgData.Area,Copy(s,Length(klArea)+1,255))
    else MainLink^.Seek(p);
   end;
  AbsData2MsgHdr(Msg,True);
  LoadMsgBody(Msg,MainLink^.GetPos,p2);
  Msg.ProcessFlags(true);
  Msg.ParseKludges;
  Msg.MsgStatus:=msLoaded;
  LoadMsg:=0;
 end;
{}
function    tPktBase.SaveMsg;
 var
  q: array[1..2] of Char;
 begin
  SaveMsg:=inherited SaveMsg(Msg,Number);
  if ExistMsg(Number) then
   begin
    DeleteMsg(Number);
    PackPkt;
   end;
  MainLink^.Seek(MainLink^.GetSize-SizeOf(qPktTrm));
  MainLink^.Read(q,SizeOf(q));
  if (q=qMsgTrm) or (q=qPktTrm) then
   begin
    MainLink^.Seek(MainLink^.GetSize-SizeOf(qMsgTrm));
    MainLink^.Write(qMsgTrm,SizeOf(qMsgTrm));
   end
  else MainLink^.Write(MsgTrm,SizeOf(MsgTrm));
  Msg.ProcessFlags(false);
  AbsData2MsgHdr(Msg,false);
  MainLink^.Write(PktMsgHdr,SizeOf(PktMsgHdr));
  with Msg.AbsMsgData do
   begin
    StreamWriteLn(MainLink^,GetPS(DestName),zr);
    StreamWriteLn(MainLink^,GetPS(OrigName),zr);
    StreamWriteLn(MainLink^,GetPS(Subject),zr);
    if (GetPS(Area)<>'') then StreamWriteLn(MainLink^,klArea+GetPS(Area),cr);
   end;
  SaveMsgBody(Msg,MainLink^.GetPos);
  MainLink^.Write(PktTrm,SizeOf(PktTrm));
  Coords^.Insert(New(PCoords,Init(MainLink^.GetSize-3)));
  Inc(Count);
  Msg.MsgStatus:=msSaved;
  SaveMsg:=0;
 end;
{}
function    tPktBase.LoadMsgReplies;
 begin
  LoadMsgReplies:=inherited LoadMsgReplies(Msg,Number);
  if (BaseStatus<>bsOpened) then exit;
  if @Msg=nil then exit;
  if not ExistMsg(Number) then exit;
  LoadMsgReplies:=LoadMsg(msg,Number);
 end;
{}
function    tPktBase.DeleteMsg;
 var
  CoordsObj: PCoords;
  p1,p2: LongInt;
 begin
  DeleteMsg:=inherited DeleteMsg(Number);
  if (BaseStatus<>bsOpened) then Exit;
  if not ExistMsg(Number) then exit;
  if (Number>Coords^.Count-1) or (Number<1) then exit;
  if MainLink^.GetSize<=60 then exit;
  CoordsObj:=Coords^.At(Number-1); p1:=CoordsObj^.c;
  CoordsObj:=Coords^.At(Number); p2:=CoordsObj^.c;
  if Number=1 then p1:=58;
  Kills^.Insert(New(pPos,Init(p1,p2)));
  DeleteMsg:=0;
 end;
{}
function    tPktBase.PackPkt;
 begin
  NewCutStream(MainLink^,Kills^);
  Kills^.FreeAll;
  LoadBaseHdr(GetPS(BaseFileName),ShareMode);
  PackPkt:=0;
 end;
{}
procedure   tPktBase.AbsData2MsgHdr;
 begin
  inherited AbsData2MsgHdr(Msg,r);
  if R then with Msg.AbsMsgData do
   begin
    OrigNode:=PktMsgHdr.OrigNode;
    DestNode:=PktMsgHdr.DestNode;
    OrigNet:=PktMsgHdr.OrigNet;
    DestNet:=PktMsgHdr.DestNet;
    Attr:=PktMsgHdr.Attr;
    Cost:=PktMsgHdr.Cost;
    Date:=StrPas(@PktMsgHdr.Date);
   end
  else with PktMsgHdr do
   begin
    FillChar(PktHdr,SizeOf(PktHdr),#0);
    OrigNode:=Msg.AbsMsgData.OrigNode;
    DestNode:=Msg.AbsMsgData.DestNode;
    OrigNet:=Msg.AbsMsgData.OrigNet;
    DestNet:=Msg.AbsMsgData.DestNet;
    Attr:=Msg.AbsMsgData.Attr;
    Cost:=Msg.AbsMsgData.Cost;
    if (not ValidTime(Msg.AbsMsgData.DateWritten)) then GetCurrentTime(Msg.AbsMsgData.DateWritten);
    if (not ValidTime(Msg.AbsMsgData.DateArrived)) then GetCurrentTime(Msg.AbsMsgData.DateArrived);
    Msg.AbsMsgData.Date:=GetFscTime(Msg.AbsMsgData.DateWritten);
    StrPCopy(@Date,Msg.AbsMsgData.Date);
   end;
 end;
{}
function    FastPktSave(Name: String; var Msg: tAbsMsg): Byte;
 var
  q: array[1..2] of Char;
  Link: pStream;
  PktMsgHdr: tPktMsgHdr;

 procedure   AbsData2MsgHdr(var Msg: tAbsMsg);
  begin
   with PktMsgHdr do
    begin
     OrigNode:=Msg.AbsMsgData.OrigNode;
     DestNode:=Msg.AbsMsgData.DestNode;
     OrigNet:=Msg.AbsMsgData.OrigNet;
     DestNet:=Msg.AbsMsgData.DestNet;
     Attr:=Msg.AbsMsgData.Attr;
     Cost:=Msg.AbsMsgData.Cost;
     if (not ValidTime(Msg.AbsMsgData.DateWritten)) then GetCurrentTime(Msg.AbsMsgData.DateWritten);
     if (not ValidTime(Msg.AbsMsgData.DateArrived)) then GetCurrentTime(Msg.AbsMsgData.DateArrived);
     Msg.AbsMsgData.Date:=GetFscTime(Msg.AbsMsgData.DateWritten);
     StrPCopy(@Date,Msg.AbsMsgData.Date);
    end;
  end;

 function    SaveMsgBody(var Msg: tAbsMsg; FromPos: Longint): Byte;
  var
   x: Longint;
  begin
   SaveMsgBody:=1;
   if @Msg=nil then exit;
   if Link=nil then exit;
   with Msg.AbsMsgData do
    begin
     if (GetPS(Area)='') then
      begin
       if (OrigPoint<>0) then StreamWriteLn(Link^,klFMPT+NToC(OrigPoint),cr);
       if (DestPoint<>0) then StreamWriteLn(Link^,klTOPT+NToC(DestPoint),cr);
       if (GetPS(INTL)<>'') then StreamWriteLn(Link^,klINTL+GetPS(INTL),cr);
      end;
     if (GetPS(MsgID)<>'') then StreamWriteLn(Link^,klMsgID+GetPS(MsgID),cr);
     if (GetPS(Reply)<>'') then StreamWriteLn(Link^,klReply+GetPS(Reply),cr);
     if (GetPS(Flags)<>'') then StreamWriteLn(Link^,klFlags+GetPS(Flags),cr);
     if (GetPS(PID)<>'') then StreamWriteLn(Link^,klPID+GetPS(PID),cr);
     if (GetPS(TID)<>'') then StreamWriteLn(Link^,klTID+GetPS(TID),cr);
     if (Msg.OtherCol^.Count>0) then for x:=0 to Msg.OtherCol^.Count-1 do StreamWriteLn(Link^,GetPS(Msg.OtherCol^.At(x)),cr);
    end;
   with Msg do
    begin
     MsgBody^.Reset;
     MsgBody^.Seek(0);
     Link^.CopyFrom(MsgBody^,MsgBody^.GetSize);
     with AbsMsgData do
      begin
       if ((GetPS(TearLine)<>'') and (TearLined)) then StreamWriteLn(Link^,bTearLine+GetPS(TearLine),cr);
       if ((GetPS(Origin)<>'') or (GetPS(Area)<>'')) and (Origined) then
       StreamWriteLn(Link^,bOrigin+GetPS(Origin)+Bracket1+GetSourceAddress+Bracket2,cr);
      end;
     if ViaCol^.Count>0 then for x:=0 to ViaCol^.Count-1 do StreamWriteLn(Link^,GetPS(ViaCol^.At(x)),cr);
    end;
  end;

 begin
  FastPktSave:=1;
  if not Exist(Name) then exit;
  Link:=New(pBufStream,Init(Name,stOpen,BlockSize));
  with Link^ do Seek(GetSize-SizeOf(qPktTrm));
  Link^.Read(q,SizeOf(q));
  if (q=qMsgTrm) or (q=qPktTrm) then
   begin
    with Link^ do Seek(GetSize-SizeOf(qMsgTrm));
    Link^.Write(qMsgTrm,SizeOf(qMsgTrm));
   end
  else Link^.Write(MsgTrm,SizeOf(MsgTrm));
  Msg.ProcessFlags(false);
  AbsData2MsgHdr(Msg);
  Link^.Write(PktMsgHdr,SizeOf(PktMsgHdr));
  with Msg.AbsMsgData do
   begin
    StreamWriteLn(Link^,GetPS(DestName),zr);
    StreamWriteLn(Link^,GetPS(OrigName),zr);
    StreamWriteLn(Link^,GetPS(Subject),zr);
    if (GetPS(Area)<>'') then StreamWriteLn(Link^,klArea+GetPS(Area),cr);
   end;
  SaveMsgBody(Msg,Link^.GetPos);
  Link^.Write(PktTrm,SizeOf(PktTrm));
  Msg.MsgStatus:=msSaved;
  DisposeObj(Link);
  FastPktSave:=0;
 end;
{}
end.
