{

Path and Seen-By processor
(c) 2000 by raVen

supported compilers: borland pascal 7.0, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rPSB;
interface
Uses Objects, rObjects;
{}
const
 LineLen: Byte = 67;
{}
type
 pPSB = ^tPSB;
 tPSB = object(tObject)
  Addrs: pStrLines;
  DefaultZone: Word;
  constructor Init(aDefaultZone: Word);
  destructor Done; virtual;
  procedure AddLine(s: String);
  function ExistAddr(const s: String): Boolean;
  procedure GetPSBLines(var Lines: tStrLines);
 end;
{}
implementation
Uses rStrings;
{}
constructor tPSB.Init;
 begin
  New(Addrs,Init(16,16));
  DefaultZone:=aDefaultZone;
 end;
{}
destructor tPSB.Done;
 begin
  DisposeObj(Addrs);
 end;
{}
procedure tPSB.AddLine;
 var
  x: Integer;
  s1: String;
  n: Word;
 begin
  if (s='') then exit;
  s1:='';
  for x:=1 to Length(s) do
   begin
    if not (s[x] in SpaceChars) then s1:=s1+s[x];
    if ((s1<>'') and (s[x] in SpaceChars)) or ((s1<>'') and (x=Length(s))) then
     begin
      if (n=0) or (Pos(Slash,s1)>0) then
       begin
        n:=CToN(ExtractWord(1,s1,[Slash]));
        s1:=ExtractWord(2,s1,[Slash]);
       end;
      s1:=NToC(DefaultZone)+DualPoint+NToC(n)+Slash+s1;
      Addrs^.Insert(NewStr(s1));
      s1:='';
     end;
   end;
 end;
{
 -- too slow
 var
  x,w: Integer;
  s1: String;
  n: Word;
 begin
  w:=WordCount(s,SpaceChars);
  n:=0;
  for x:=1 to w do
   begin
    s1:=ExtractWord(x,s,[Space]);
    if (n=0) or (Pos(Slash,s1)>0) then
     begin
      n:=CToN(ExtractWord(1,s1,[Slash]));
      s1:=ExtractWord(2,s1,[Slash]);
     end;
    s1:=NToC(DefaultZone)+DualPoint+NToC(n)+Slash+s1;
    Addrs^.Insert(NewStr(s1));
   end;
 end;
}
{}
function tPSB.ExistAddr;
 var
  x: Integer;
 begin
  ExistAddr:=False;
  with Addrs^ do if Count>0 then for x:=0 to Count-1 do if GetPS(At(x))=s then
   begin
    ExistAddr:=True;
    exit;
   end;
 end;
{}
procedure tPSB.GetPSBLines;
 var
  x: Integer;
  s,s1: String;
  n: Word;
 begin
  if @Lines=nil then exit;
  s:='';
  n:=0;
  with Addrs^ do if Count>0 then for x:=0 to Count-1 do
   begin
    s1:=ExtractWord(2,GetPS(At(x)),[DualPoint]);
    if CToN(ExtractWord(1,s1,[Slash]))=n then s1:=ExtractWord(2,s1,[Slash])
    else n:=CToN(ExtractWord(1,s1,[Slash]));
    if (Length(s)+Length(s1)>LineLen) then
     begin
      Lines.Insert(NewStr(Trim(s,SpaceChars)));
      s:='';
      if Pos(Slash,s1)<=0 then s1:=NToC(n)+Slash+s1;
     end;
    s:=s+s1+Space;
   end;
  if s<>'' then Lines.Insert(NewStr(Trim(s,SpaceChars)));
 end;
{}
end.
