{&Use32+,D+,L+,LocInfo+}
{$IfDef DPMI}
{$M 65500}
{$EndIf}
Uses Error,
 rAbs, rJam, rSquish, rFidoMsg, rObjects, Objects, rCommon, OpCrt, rOpen,
 rStrings, Dos, rTime
{$IfDef VirtualPascal}
,VPUtils;
{$EndIf}
{$IfDef Ver70}
;
{$EndIf}
type

 pMsgCol = ^tMsgCol;
 tMsgCol = object(trSortedCollection)
  function Compare(Key1,Key2: Pointer): Integer; virtual;
 end;

function tMsgCol.Compare;
 var
  Msg1: pAbsMsg absolute Key1;
  Msg2: pAbsMsg absolute Key2;
  l1,l2: Longint;
 begin
  PackUnixTime(Msg1^.AbsMsgData.DateWritten,l1);
  PackUnixTime(Msg2^.AbsMsgData.DateWritten,l2);
  if l1<l2 then Compare:=-1
   else if l1=l2 then Compare:=0
    else if l1>l2 then Compare:=1;
 end;

procedure SortBase(OrigPath: String);
 var
  q,OrigBase: pAbsBase;
  MsgCol: pMsgCol;
  Msg: pAbsMsg;
  px,py: Byte;
  x,t: Longint;
 begin
  WriteLn('mode: [sorting all base]');
  WriteLn('source base: [', OrigPath, ']');
  OrigBase:=OpenOrCreateBase(OrigPath,stDenyWrite);
  if OrigBase=nil then
   begin
    WriteLn('can''t open source base: ['+OrigPath+']');
    exit;
   end
  else WriteLn('source base opened');
  WriteLn('source base - total ',OrigBase^.Count);
  New(MsgCol,Init(16,16));
  MsgCol^.Duplicates:=True;
  Write('reading message... ');
  px:=WhereX; py:=WhereY;
  New(Msg,Init);
  t:=0;
  for x:=1 to OrigBase^.Count do
   begin
    if (Abs(t-Timer)>200) then
     begin
      t:=timer;
      FastText('#'+NToC(x),py,px);
     end;
    if OrigBase^.LoadMsg(Msg^,x)=0 then
     begin
      FillChar(Msg^.AbsMsgData.Replies,SizeOf(Msg^.AbsMsgData.Replies),0);
      Msg^.AbsMsgData.ReplyTo:=0;
      MsgCol^.Insert(Msg);
      New(Msg,Init);
     end;
    if KeyPressed then if ReadKey=#27 then
     begin
      WriteLn('terminated!');
      Halt;
     end;
   end;
  FastText('#'+NToC(x-1),py,px);
  WriteLn;
  Write('writing message... ');
//  asm int 3 end;
  px:=WhereX; py:=WhereY;
  DisposeObj(OrigBase);
  KillBase(OrigPath);
  OrigBase:=CreateBase(OrigPath,stDenyWrite);
  if MsgCol^.Count>0 then for x:=0 to MsgCol^.Count-1 do
   begin
    if (Abs(t-Timer)>200) then
     begin
      t:=timer;
      FastText('#'+NToC(x+1),py,px);
     end;
    OrigBase^.SaveMsg(pAbsMsg(MsgCol^.At(x))^,x+1);
    if KeyPressed then if ReadKey=#27 then
     begin
      WriteLn('terminated!');
      Halt;
     end;
   end;
  FastText('#'+NToC(x),py,px);
  WriteLn;

  DisposeObj(Msg);
  DisposeObj(MsgCol);
  DisposeObj(OrigBase);
  WriteLn;
 end;

procedure SortUnreadBase(OrigPath: String);
 var
  q,OrigBase: pAbsBase;
  SorMsgCol: pMsgCol;
  UnsMsgCol: pCollection;
  Msg: pAbsMsg;
  px,py: Byte;
  x,t: Longint;
 begin
  WriteLn('mode: [sorting unreaded messages]');
  WriteLn('source base: [', OrigPath, ']');
  OrigBase:=OpenOrCreateBase(OrigPath,stDenyWrite);
  if OrigBase=nil then
   begin
    WriteLn('can''t open source base: ['+OrigPath+']');
    exit;
   end
  else WriteLn('source base opened');
  WriteLn('source base - total ',OrigBase^.Count);
  New(SorMsgCol,Init(16,16));
  New(UnsMsgCol,Init(16,16));
  SorMsgCol^.Duplicates:=True;
  Write('reading message... ');
  px:=WhereX; py:=WhereY;
  New(Msg,Init);
  t:=0;
  for x:=1 to OrigBase^.Count do
   begin
    if (Abs(t-Timer)>200) then
     begin
      t:=timer;
      FastText('#'+NToC(x),py,px);
     end;
    if OrigBase^.LoadMsg(Msg^,x)=0 then
     begin
      FillChar(Msg^.AbsMsgData.Replies,SizeOf(Msg^.AbsMsgData.Replies),0);
      Msg^.AbsMsgData.ReplyTo:=0;
      if Msg^.AbsMsgData.TimesRead<=0 then
       begin
        SorMsgCol^.Insert(Msg);
        New(Msg,Init);
       end
      else
       begin
        FillChar(Msg^.AbsMsgData.Replies,SizeOf(Msg^.AbsMsgData.Replies),0);
        Msg^.AbsMsgData.ReplyTo:=0;
        UnsMsgCol^.Insert(Msg);
        New(Msg,Init);
       end;
     end;
    if KeyPressed then if ReadKey=#27 then
     begin
      WriteLn('terminated!');
      Halt;
     end;
   end;
  FastText('#'+NToC(x-1),py,px);
  WriteLn;
  Write('writing message... ');
  px:=WhereX; py:=WhereY;
  DisposeObj(OrigBase);
  KillBase(OrigPath);
  OrigBase:=CreateBase(OrigPath,stDenyWrite);

  if UnsMsgCol^.Count>0 then for x:=0 to UnsMsgCol^.Count-1 do
   begin
    if (Abs(t-Timer)>200) then
     begin
      t:=timer;
      FastText('#'+NToC(x+1),py,px);
     end;
    OrigBase^.SaveMsg(pAbsMsg(UnsMsgCol^.At(x))^,x+1);
    if KeyPressed then if ReadKey=#27 then
     begin
      WriteLn('terminated!');
      Halt;
     end;
   end;

  if SorMsgCol^.Count>0 then for x:=UnsMsgCol^.Count to SorMsgCol^.Count+UnsMsgCol^.Count-1 do
   begin
    if (Abs(t-Timer)>200) then
     begin
      t:=timer;
      FastText('#'+NToC(x+1),py,px);
     end;
    OrigBase^.SaveMsg(pAbsMsg(SorMsgCol^.At(x-UnsMsgCol^.Count))^,x+1);
    if KeyPressed then if ReadKey=#27 then
     begin
      WriteLn('... terminated');
      Halt;
     end;
   end;
  FastText('#'+NToC(x),py,px);
  WriteLn;

  DisposeObj(Msg);
  DisposeObj(SorMsgCol);
  DisposeObj(UnsMsgCol);
  DisposeObj(OrigBase);
  WriteLn;
 end;

var
 WasMem: Longint;
 s: String;
 t: Text;
 l: Integer;
begin
{$IfDef Ver70}
 WasMem:=MemAvail;
{$EndIf}
{$IfDef VirtualPascal}
 WasMem:=MemUsed;
{$EndIf}
 WriteLn;
 WriteLn('raVen''s message base sorter, v0.04 (c) 1999-2000 by raVen');
 WriteLn;
 if (ParamCount>2) or (ParamCount<1) then
  begin
   WriteLn('Usage: rMsgSort <sourcebase> [/u]');
   WriteLn('Example: rMsgSort fF:\Fido\Netmail\Share');
   WriteLn('         rMsgSort sF:\Fido\Base');
   WriteLn('         f - msg (fido), s - squish, j - jam, p - pkt 2.0+, @ - areas.bbs');
   WriteLn(' /u - sort unread messages only');
   Halt;
  end;

 s:=ParamStr(1);

 case UpCase(s[1]) of
  'F','S','J','P','!','$','#': if UpStr(ParamStr(2))='/U' then SortUnreadBase(s) else SortBase(s);
  '@':
   begin
    NewDelete(s,1,1);
    if not Exist(s) then
     begin
      WriteLn('areafile: ['+s+'] is NOT found');
      Halt($FE);
     end;
    Assign(t,s); Reset(t);
    while not eof(t) do
     begin
      ReadLn(t,s);
      l:=Pos(';',s);
      if l>0 then NewDelete(s,l,Length(s));
      if s='' then continue;
      s:=ExtractWord(1,Trim(s,SpaceChars),SpaceChars);
      SortBase(s);
     end;
    Close(t);
   end;
 end;

{$IfDef VirtualPascal}
 WriteLn('Memory leak is ', MemUsed - WasMem, ' bytes.');
{$EndIf}
{$IfDef Ver70}
 WriteLn('Memory leak is ', WasMem - MemAvail, ' bytes.');
{$EndIf}
end.
