{

time functions
portions (c) 1999-2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rTime;
interface
Uses Dos;
{}
const
{( for calculating unix date )}
   C1970 = 2440588;
   D0 =    1461;
   D1 =  146097;
   D2 = 1721119;
{( processing unix date )}
 procedure UnpackUnixTime(Time: LongInt; var DT: DateTime);
 procedure PackUnixTime(DT: DateTime; var Time: Longint);
{}
 function    GetFscTime(dt: DateTime): String;
{}
 procedure   GetCurrentTime(var DT:DateTime);
 function    GetCurrentDosTime: Longint;
 function    GetCurrentUnixTime: Longint;
 function    GetCurrentFscTime: String;
{}
 function DateStr(const dt: DateTime): String;
 function TimeStr(const dt: DateTime): String;
{}
 function ValidTime(var dt: DateTime): Boolean;
{}
implementation
Uses rStrings, rCommon;
{( processing unix date )}
procedure   GToJ(var JDate: Longint; DT: DateTime);
 var
  Century: LongInt;
  XYear  : LongInt;
  Temp   : LongInt;
  Month  : LongInt;
 begin
  Month:=DT.Month;
  if Month<=2 then
   begin
    Dec(DT.Year);
    Inc(Month,12);
   end;
  Dec(Month,3);
  Century:=DT.Year div 100;
  XYear:=DT.Year mod 100;
  Century:=(Century * D1) shr 2;
  XYear:=(XYear * D0) shr 2;
  JDate:=((((Month*153)+2) div 5)+DT.Day)+D2+XYear+Century;
 end;
{}
procedure   JToG(JDate: LongInt; var DT: DateTime);
 var
  Temp, XYear: LongInt;
  YYear, YMonth,
  YDay: Integer;
 begin
  Temp:=(((JDate-D2) shl 2)-1);
  XYear:=(Temp mod D1) or 3;
  JDate:=temp div D1;
  YYear:=(XYear div D0);
  Temp:=((((XYear mod D0)+4) shr 2)*5)-3;
  YMonth:=Temp div 153;
  if YMonth>=10 then
   begin
    YYear:= YYear+1;
    YMonth:=YMonth-12;
   end;
  YMonth:=YMonth+3;
  YDay:=Temp mod 153;
  YDay:=(YDay+5) div 5;
  DT.Year:=YYear+(JDate * 100);
  DT.Month := YMonth;
  DT.Day := YDay;
 end;
{}
procedure   UnpackUnixTime(Time: LongInt; var DT: DateTime);
 var
  DateNum: LongInt;
 begin
  Datenum:=(Time div 86400)+c1970;
  JToG(DateNum,DT);
  Time:=Time mod 86400;
  DT.Hour:=Time div 3600;
  Time:=Time mod 3600;
  DT.Min:=Time div 60;
  DT.Sec:=Time mod 60;
 end;
{}
procedure   PackUnixTime(DT: DateTime; var Time: Longint);
 var
  SecsPast, DaysPast, q: LongInt;
 begin
  GToJ(q,DT);
  DaysPast:=q-c1970;
  SecsPast:=DaysPast*86400;
  SecsPast:=SecsPast+(LongInt(DT.Hour)*3600)+(DT.Min*60)+(DT.Sec);
  Time := SecsPast;
 end;
{}
function    GetFscTime(dt: DateTime): String;
 begin
  GetFscTime:=LeadZero(dt.day,2)+' '+MonthNameSE[dt.month]+' '+LeadZero(dt.year,2)+
              '  '+LeadZero(dt.hour,2)+DualPoint+LeadZero(dt.min,2)+DualPoint+LeadZero(dt.sec,2);
 end;
{}
procedure   GetCurrentTime(var DT:DateTime);
 var
  x: Word;
 begin
  with DT do
   begin
    GetDate(Year,Month,Day,x);
    GetTime(Hour,Min,Sec,x);
   end;
 end;
{}
function    GetCurrentDosTime: Longint;
 var
  dt: DateTime;
  l: Longint;
 begin
  GetCurrentTime(dt);
  PackTime(dt,l);
  GetCurrentDosTime:=l;
 end;
{}
function    GetCurrentUnixTime: Longint;
 var
  dt: DateTime;
  l: Longint;
 begin
  GetCurrentTime(dt);
  PackUnixTime(dt,l);
  GetCurrentUnixTime:=l;
 end;
{}
function    GetCurrentFscTime: String;
 var
  dt: DateTime;
  l: Longint;
 begin
  GetCurrentTime(dt);
  GetCurrentFscTime:=GetFscTime(dt);
 end;
{}
function DateStr(const dt: DateTime): String;
 begin
  DateStr:=LeftPadCh(NToC(dt.Day),'0',2)+Slash+LeftPadCh(NToC(dt.Month),'0',2)+Slash+LeftPadCh(NToC(dt.Year mod 100),'0',2);
 end;
{}
function TimeStr(const dt: DateTime): String;
 begin
  TimeStr:=LeftPadCh(NToC(dt.Hour),'0',2)+DualPoint+LeftPadCh(NToC(dt.Min),'0',2)+DualPoint+LeftPadCh(NToC(dt.Sec),'0',2);
 end;
{}
function ValidTime(var dt: DateTime): Boolean;
 begin
  ValidTime:=False;
  with (dt) do
   begin
    if (Year>1900) and (Year<2100) and
       (Month>0) and (Month<13) and
       (Day>0) and (Day<32) and
       (Hour>0) and (Hour<25) and
       (Min>0) and (Min<61) and
       (Sec>0) and (Sec<61) then ValidTime:=True;
   end;
 end;
{}
end.
